Package org.apache.tapestry5.json

## Class JSONObject

- java.lang.Object
- - org.apache.tapestry5.json.JSONCollection
  - - org.apache.tapestry5.json.JSONObject

- All Implemented Interfaces:
    `java.io.Serializable`, `java.util.Map<java.lang.String,​java.lang.Object>`

      public final class JSONObject
      extends JSONCollection
      implements java.util.Map<java.lang.String,​java.lang.Object>

  A modifiable set of name/value mappings. Names are unique, non-null strings. Values may be any mix of `JSONObjects`, `JSONArrays`, Strings, Booleans, Integers, Longs, Doubles or `NULL`. Values may not be `null`, `NaNs`, `infinities`, or of any type not listed here.

  This class can coerce values to another type when requested.

  - When the requested type is a boolean, strings will be coerced using a case-insensitive comparison to "true" and "false".
  - When the requested type is a double, other `Number` types will be coerced using `doubleValue`. Strings that can be coerced using `Double.valueOf(String)` will be.
  - When the requested type is an int, other `Number` types will be coerced using `intValue`. Strings that can be coerced using `Double.valueOf(String)` will be, and then cast to int.
  - When the requested type is a long, other `Number` types will be coerced using `longValue`. Strings that can be coerced using `Double.valueOf(String)` will be, and then cast to long. This two-step conversion is lossy for very large values. For example, the string "9223372036854775806" yields the long 9223372036854775807.
  - When the requested type is a String, other non-null values will be coerced using `String.valueOf(Object)`. Although null cannot be coerced, the sentinel value `NULL` is coerced to the string "null".

  This class can look up both mandatory and optional values:

  - Use `getType()` to retrieve a mandatory value. This fails with a `RuntimeException` if the requested name has no value or if the value cannot be coerced to the requested type.
  - Use `opt()` to retrieve an optional value.

  Warning: this class represents null in two incompatible ways: the standard Java `null` reference, and the sentinel value `NULL`. In particular, calling `put(name, null)` removes the named entry from the object but `put(name, JSONObject.NULL)` stores an entry whose value is `JSONObject.NULL`.

  Instances of this class are not thread safe.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K extends java.lang.Object,​V extends java.lang.Object>`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.Object` | `NULL` | A sentinel value used to explicitly define a name with no value.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JSONObject()` | Creates a `JSONObject` with no name/value mappings.
    `JSONObject​(java.lang.Object... keysAndValues)` | Constructs a new JSONObject using a series of String keys and object values.
    `JSONObject​(java.lang.String json)` | Creates a new `JSONObject` with name/value mappings from the JSON string.
    `JSONObject​(JSONObject copyFrom, java.lang.String... names)` | Creates a new `JSONObject` by copying mappings for the listed names from the given object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `JSONObject` | `accumulate​(java.lang.String name, java.lang.Object value)` | Appends `value` to the array already mapped to `name`.
    `JSONObject` | `append​(java.lang.String name, java.lang.Object value)` | Appends values to the array mapped to `name`.
    `void` | `clear()` | Removes all of the mappings from this JSONObject.
    `boolean` | `containsKey​(java.lang.Object key)` | Returns `true` if this JSONObject contains a mapping for the specified key.
    `boolean` | `containsValue​(java.lang.Object value)` | Returns `true` if this JSONObject maps one or more keys to the specified value.
    `JSONObject` | `copy()` | Returns a new JSONObject that is a shallow copy of this JSONObject.
    `java.util.Set<java.util.Map.Entry<java.lang.String,​java.lang.Object>>` | `entrySet()` | Returns a `Set` view of the mappings contained in this JSONObject.
    `boolean` | `equals​(java.lang.Object obj)` |
    `java.lang.Object` | `get​(java.lang.Object name)` | Returns the value mapped by `name`, or throws if no such mapping exists.
    `boolean` | `getBoolean​(java.lang.String name)` | Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or throws otherwise.
    `boolean` | `getBooleanOrDefault​(java.lang.String name, boolean defaultValue)` | Returns the value to which the specified key is mapped and a boolean, or `defaultValue` if this JSONObject contains no mapping for the key.
    `double` | `getDouble​(java.lang.String name)` | Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or throws otherwise.
    `int` | `getInt​(java.lang.String name)` | Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or throws otherwise.
    `int` | `getIntOrDefault​(java.lang.String name, int defaultValue)` | Returns the value to which the specified key is mapped and an int, or `defaultValue` if this JSONObject contains no mapping for the key.
    `JSONArray` | `getJSONArray​(java.lang.String name)` | Returns the value mapped by `name` if it exists and is a `JSONArray`, or throws otherwise.
    `JSONArray` | `getJSONArrayOrDefault​(java.lang.String name, JSONArray defaultValue)` | Returns the value to which the specified key is mapped and a JSONArray, or `defaultValue` if this JSONObject contains no mapping for the key.
    `JSONObject` | `getJSONObject​(java.lang.String name)` | Returns the value mapped by `name` if it exists and is a `JSONObject`, or throws otherwise.
    `JSONObject` | `getJSONObjectOrDefault​(java.lang.String name, JSONObject defaultValue)` | Returns the value to which the specified key is mapped and a JSONObject, or `defaultValue` if this map contains no mapping for the key.
    `long` | `getLong​(java.lang.String name)` | Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or throws otherwise.
    `long` | `getLongOrDefault​(java.lang.String name, long defaultValue)` | Returns the value to which the specified key is mapped and a long, or `defaultValue` if this JSONObject contains no mapping for the key.
    `java.lang.Object` | `getOrDefault​(java.lang.Object key, java.lang.Object defaultValue)` | Returns the value to which the specified key is mapped, or `defaultValue` if this JSONObject contains no mapping for the key.
    `java.lang.String` | `getString​(java.lang.String name)` | Returns the value mapped by `name` if it exists, coercing it if necessary, or throws if no such mapping exists.
    `java.lang.String` | `getStringOrDefault​(java.lang.String name, java.lang.String defaultValue)` | Returns the value to which the specified key is mapped and a string, or `defaultValue` if this JSONObject contains no mapping for the key.
    `boolean` | `has​(java.lang.String name)` | Deprecated. use `containsKey(Object)` instead
    `int` | `hashCode()` |
    `JSONObject` | `in​(java.lang.String key)` | Navigates into a nested JSONObject, creating the JSONObject if necessary.
    `boolean` | `isEmpty()` | Returns `true` if this JSONObject contains no key-value mappings.
    `boolean` | `isNull​(java.lang.String name)` | Returns true if this object has no mapping for `name` or if it has a mapping whose value is `NULL`.
    `java.util.Set<java.lang.String>` | `keys()` | Returns the set of `String` names in this object.
    `java.util.Set<java.lang.String>` | `keySet()` | Returns a `Set` view of the keys contained in this JSONObject.
    `int` | `length()` | Deprecated. Use `size()` instead.
    `java.lang.Object` | `merge​(java.lang.String key, java.lang.Object value, java.util.function.BiFunction<? super java.lang.Object,​? super java.lang.Object,​? extends java.lang.Object> remappingFunction)` | If the specified key is not already associated with a value or is associated with null, associates it with the given non-null value.
    `JSONArray` | `names()` | Returns an array containing the string names in this object.
    `static java.lang.String` | `numberToString​(java.lang.Number number)` | Encodes the number as a JSON string.
    `java.lang.Object` | `opt​(java.lang.Object name)` | Returns the value mapped by `name`, or null if no such mapping exists.
    `JSONObject` | `put​(java.lang.String name, java.lang.Object value)` | Maps `name` to `value`, clobbering any existing name/value mapping with the same name.
    `void` | `putAll​(java.util.Map<? extends java.lang.String,​? extends java.lang.Object> newProperties)` | Invokes `put(String, Object)` for each value from the map.
    `static java.lang.String` | `quote​(java.lang.String data)` | Encodes `data` as a JSON string.
    `java.lang.Object` | `remove​(java.lang.Object name)` | Removes the named mapping if it exists; does nothing otherwise.
    `int` | `size()` | Returns the number of key-value mappings in this JSONObject.
    `java.util.Map<java.lang.String,​java.lang.Object>` | `toMap()` | Returns a Map of the keys and values of the JSONObject.
    `java.util.Collection<java.lang.Object>` | `values()` | Returns a `Collection` view of the values contained in this JSONObject.

    - ### Methods inherited from class org.apache.tapestry5.json.JSONCollection

      `prettyPrint, print, print, toCompactString, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, forEach, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Field Detail

    - #### NULL

          public static final java.lang.Object NULL

      A sentinel value used to explicitly define a name with no value. Unlike `null`, names with this value:
      - show up in the `names()` array
      - show up in the `keys()` iterator
      - return `true` for `has(String)`
      - do not throw on `get(java.lang.Object)`
      - are included in the encoded JSON string.

      This value violates the general contract of `Object.equals(java.lang.Object)` by returning true when compared to `null`. Its `JSONCollection.toString()` method returns "null".

  - ### Constructor Detail

    - #### JSONObject

          public JSONObject()

      Creates a `JSONObject` with no name/value mappings.

    - #### JSONObject

          public JSONObject​(java.lang.String json)

      Creates a new `JSONObject` with name/value mappings from the JSON string.
      Parameters:
        `json` - a JSON-encoded string containing an object.
      Throws:
        `java.lang.RuntimeException` - if the parse fails or doesn't yield a `JSONObject`.

    - #### JSONObject

          public JSONObject​(JSONObject copyFrom,
                            java.lang.String... names)

      Creates a new `JSONObject` by copying mappings for the listed names from the given object. Names that aren't present in `copyFrom` will be skipped.
      Parameters:
        `copyFrom` - The source object.
        `names` - The names of the fields to copy.
      Throws:
        `java.lang.RuntimeException` - On internal errors. Shouldn't happen.

    - #### JSONObject

          public JSONObject​(java.lang.Object... keysAndValues)

      Constructs a new JSONObject using a series of String keys and object values. Object values should be compatible with `put(String, Object)`. Keys must be strings (toString() will be invoked on each key). Prior to release 5.4, keysAndValues was type String...; changing it to Object... makes it much easier to initialize a JSONObject in a single statement, which is more readable.
      Since:
        5.2.0

  - ### Method Detail

    - #### copy

          public JSONObject copy()

      Returns a new JSONObject that is a shallow copy of this JSONObject.
      Since:
        5.4

    - #### length

          @Deprecated
          public int length()

      Deprecated.
      Use `size()` instead.
      Returns the number of name/value mappings in this object.
      Returns:
        the length of this.

    - #### put

          public JSONObject put​(java.lang.String name,
                                java.lang.Object value)

      Maps `name` to `value`, clobbering any existing name/value mapping with the same name. If the value is `null`, any existing mapping for `name` is removed.
      Specified by:
        `put` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Parameters:
        `name` - The name of the new value.
        `value` - a `JSONObject`, `JSONArray`, String, Boolean, Integer, Long, Double, `NULL`, or `null`. May not be `NaNs` or `infinities`.
      Returns:
        this object.
      Throws:
        `java.lang.IllegalArgumentException` - if the value is an invalid double (infinite or NaN).

    - #### accumulate

          public JSONObject accumulate​(java.lang.String name,
                                       java.lang.Object value)

      Appends `value` to the array already mapped to `name`. If this object has no mapping for `name`, this inserts a new mapping. If the mapping exists but its value is not an array, the existing and new values are inserted in order into a new array which is itself mapped to `name`. In aggregate, this allows values to be added to a mapping one at a time. Note that `append(String, Object)` provides better semantics. In particular, the mapping for `name` will always be a `JSONArray`. Using `accumulate` will result in either a `JSONArray` or a mapping whose type is the type of `value` depending on the number of calls to it.
      Parameters:
        `name` - The name of the field to change.
        `value` - a `JSONObject`, `JSONArray`, String, Boolean, Integer, Long, Double, `NULL` or null. May not be `NaNs` or `infinities`.
      Returns:
        this object after mutation.
      Throws:
        `java.lang.RuntimeException` - If the object being added is an invalid number.

    - #### append

          public JSONObject append​(java.lang.String name,
                                   java.lang.Object value)

      Appends values to the array mapped to `name`. A new `JSONArray` mapping for `name` will be inserted if no mapping exists. If the existing mapping for `name` is not a `JSONArray`, a `RuntimeException` will be thrown.
      Parameters:
        `name` - The name of the array to which the value should be appended.
        `value` - The value to append.
      Returns:
        this object.
      Throws:
        `JSONTypeMismatchException` - if `name` is `null` or if the mapping for `name` is non-null and is not a `JSONArray`.

    - #### isNull

          public boolean isNull​(java.lang.String name)

      Returns true if this object has no mapping for `name` or if it has a mapping whose value is `NULL`.
      Parameters:
        `name` - The name of the value to check on.
      Returns:
        true if the field doesn't exist or is null.

    - #### has

          @Deprecated
          public boolean has​(java.lang.String name)

      Deprecated.
      use `containsKey(Object)` instead
      Returns true if this object has a mapping for `name`. The mapping may be `NULL`.
      Parameters:
        `name` - The name of the value to check on.
      Returns:
        true if this object has a field named `name`

    - #### opt

          public java.lang.Object opt​(java.lang.Object name)

      Returns the value mapped by `name`, or null if no such mapping exists.
      Parameters:
        `name` - The name of the value to get.
      Returns:
        The value.

    - #### getBoolean

          public boolean getBoolean​(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or throws otherwise.
      Parameters:
        `name` - The name of the field we want.
      Returns:
        The selected value if it exists.
      Throws:
        `JSONValueNotFoundException` - if the mapping doesn't exist
        `JSONTypeMismatchException` - if the mapping cannot be coerced to a boolean.

    - #### getBooleanOrDefault

          public boolean getBooleanOrDefault​(java.lang.String name,
                                             boolean defaultValue)

      Returns the value to which the specified key is mapped and a boolean, or `defaultValue` if this JSONObject contains no mapping for the key.
      Parameters:
        `name` - the key whose associated value is to be returned
        `defaultValue` - the default mapping of the key
      Returns:
        the value to which the specified key is mapped, or `defaultValue` if this JSONObject contains no mapping for the key
      Throws:
        `JSONTypeMismatchException` - if the mapping cannot be coerced to a boolean.
      Since:
        5.7

    - #### getDouble

          public double getDouble​(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or throws otherwise.
      Parameters:
        `name` - The name of the field we want.
      Returns:
        The selected value if it exists.
      Throws:
        `JSONValueNotFoundException` - if the mapping doesn't exist
        `JSONTypeMismatchException` - if the mapping cannot be coerced to a double.

    - #### getInt

          public int getInt​(java.lang.String name)

      Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or throws otherwise.
      Parameters:
        `name` - The name of the field we want.
      Returns:
        The selected value if it exists.
      Throws:
        `JSONValueNotFoundException` - if the mapping doesn't exist
        `JSONTypeMismatchException` - if the mapping cannot be coerced to an int.

    - #### getIntOrDefault

          public int getIntOrDefault​(java.lang.String name,
                                     int defaultValue)

      Returns the value to which the specified key is mapped and an int, or `defaultValue` if this JSONObject contains no mapping for the key.
      Parameters:
        `name` - the key whose associated value is to be returned
        `defaultValue` - the default mapping of the key
      Returns:
        the value to which the specified key is mapped, or `defaultValue` if this JSONObject contains no mapping for the key
      Throws:
        `JSONTypeMismatchException` - if the mapping cannot be coerced to an int.
      Since:
        5.7

    - #### getLong

          public long getLong​(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or throws otherwise. Note that JSON represents numbers as doubles, so this is lossy; use strings to transfer numbers via JSON without loss.
      Parameters:
        `name` - The name of the field that we want.
      Returns:
        The value of the field.
      Throws:
        `JSONValueNotFoundException` - if the mapping doesn't exist
        `JSONTypeMismatchException` - if the mapping cannot be coerced to a long.

    - #### getLongOrDefault

          public long getLongOrDefault​(java.lang.String name,
                                       long defaultValue)

      Returns the value to which the specified key is mapped and a long, or `defaultValue` if this JSONObject contains no mapping for the key.
      Parameters:
        `name` - the key whose associated value is to be returned
        `defaultValue` - the default mapping of the key
      Returns:
        the value to which the specified key is mapped, or `defaultValue` if this JSONObject contains no mapping for the key
      Throws:
        `JSONTypeMismatchException` - if the mapping cannot be coerced to a long.
      Since:
        5.7

    - #### getString

          public java.lang.String getString​(java.lang.String name)

      Returns the value mapped by `name` if it exists, coercing it if necessary, or throws if no such mapping exists.
      Parameters:
        `name` - The name of the field we want.
      Returns:
        The value of the field.
      Throws:
        `JSONValueNotFoundException` - if the mapping doesn't exist
        `JSONTypeMismatchException` - if the mapping cannot be coerced to String

    - #### getStringOrDefault

          public java.lang.String getStringOrDefault​(java.lang.String name,
                                                     java.lang.String defaultValue)

      Returns the value to which the specified key is mapped and a string, or `defaultValue` if this JSONObject contains no mapping for the key.
      Parameters:
        `name` - the key whose associated value is to be returned
        `defaultValue` - the default mapping of the key
      Returns:
        the value to which the specified key is mapped, or `defaultValue` if this JSONObject contains no mapping for the key
      Throws:
        `JSONTypeMismatchException` - if the mapping cannot be coerced to a string.
      Since:
        5.7

    - #### getJSONArray

          public JSONArray getJSONArray​(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a `JSONArray`, or throws otherwise.
      Parameters:
        `name` - The field we want to get.
      Returns:
        The value of the field (if it is a JSONArray.
      Throws:
        `JSONValueNotFoundException` - if the mapping doesn't exist
        `JSONTypeMismatchException` - if the mapping is not a `JSONArray`.

    - #### getJSONArrayOrDefault

          public JSONArray getJSONArrayOrDefault​(java.lang.String name,
                                                 JSONArray defaultValue)

      Returns the value to which the specified key is mapped and a JSONArray, or `defaultValue` if this JSONObject contains no mapping for the key.
      Parameters:
        `name` - the key whose associated value is to be returned
        `defaultValue` - the default mapping of the key
      Returns:
        the value to which the specified key is mapped, or `defaultValue` if this JSONObject contains no mapping for the key
      Throws:
        `JSONTypeMismatchException` - if the mapping cannot be coerced to a JSONArray.
      Since:
        5.7

    - #### getJSONObject

          public JSONObject getJSONObject​(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a `JSONObject`, or throws otherwise.
      Parameters:
        `name` - The name of the field that we want.
      Returns:
        a specified field value (if it is a JSONObject)
      Throws:
        `JSONValueNotFoundException` - if the mapping doesn't exist
        `JSONTypeMismatchException` - if the mapping is not a `JSONObject`.

    - #### getJSONObjectOrDefault

          public JSONObject getJSONObjectOrDefault​(java.lang.String name,
                                                   JSONObject defaultValue)

      Returns the value to which the specified key is mapped and a JSONObject, or `defaultValue` if this map contains no mapping for the key.
      Parameters:
        `name` - the key whose associated value is to be returned
        `defaultValue` - the default mapping of the key
      Returns:
        the value to which the specified key is mapped, or `defaultValue` if this map contains no mapping for the key
      Throws:
        `JSONTypeMismatchException` - if the mapping cannot be coerced to a JSONObject.
      Since:
        5.7

    - #### keys

          public java.util.Set<java.lang.String> keys()

      Returns the set of `String` names in this object. The returned set is a view of the keys in this object. `Set.remove(Object)` will remove the corresponding mapping from this object and set iterator behaviour is undefined if this object is modified after it is returned. See `keys()`.
      Returns:
        The names in this object.

    - #### names

          public JSONArray names()

      Returns an array containing the string names in this object. This method returns null if this object contains no mappings.
      Returns:
        the names.

    - #### numberToString

          public static java.lang.String numberToString​(java.lang.Number number)

      Encodes the number as a JSON string.
      Parameters:
        `number` - a finite value. May not be `NaNs` or `infinities`.
      Returns:
        The encoded number in string form.
      Throws:
        `java.lang.RuntimeException` - On internal errors. Shouldn't happen.

    - #### quote

          public static java.lang.String quote​(java.lang.String data)

      Encodes `data` as a JSON string. This applies quotes and any necessary character escaping.
      Parameters:
        `data` - the string to encode. Null will be interpreted as an empty string.
      Returns:
        the quoted string.

    - #### equals

          public boolean equals​(java.lang.Object obj)

      Specified by:
        `equals` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toMap

          public java.util.Map<java.lang.String,​java.lang.Object> toMap()

      Returns a Map of the keys and values of the JSONObject. The returned map is unmodifiable. Note that changes to the JSONObject will be reflected in the map. In addition, null values in the JSONObject are represented as `NULL` in the map.
      Returns:
        unmodifiable map of properties and values
      Since:
        5.4

    - #### in

          public JSONObject in​(java.lang.String key)

      Navigates into a nested JSONObject, creating the JSONObject if necessary. They key must not exist, or must be a JSONObject.
      Parameters:
        `key` -
      Returns:
        the nested JSONObject
      Throws:
        `java.lang.IllegalStateException` - if the current value for the key is not null and not JSONObject

    - #### size

          public int size()

      Returns the number of key-value mappings in this JSONObject. If it contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.
      Specified by:
        `size` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Returns:
        the number of key-value mappings in this JSONObject
      Since:
        5.7

    - #### isEmpty

          public boolean isEmpty()

      Returns `true` if this JSONObject contains no key-value mappings.
      Specified by:
        `isEmpty` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Returns:
        `true` if this JSONObject contains no key-value mappings
      Since:
        5.7

    - #### containsKey

          public boolean containsKey​(java.lang.Object key)

      Returns `true` if this JSONObject contains a mapping for the specified key.
      Specified by:
        `containsKey` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Parameters:
        `key` - key whose presence in this map is to be tested
      Returns:
        `true` if this map contains a mapping for the specified key
      Since:
        5.7

    - #### containsValue

          public boolean containsValue​(java.lang.Object value)

      Returns `true` if this JSONObject maps one or more keys to the specified value.
      Specified by:
        `containsValue` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Parameters:
        `value` - value whose presence in this map is to be tested
      Returns:
        `true` if this JSONObject maps one or more keys to the specified value
      Since:
        5.7

    - #### get

          public java.lang.Object get​(java.lang.Object name)

      Returns the value mapped by `name`, or throws if no such mapping exists.
      Specified by:
        `get` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Parameters:
        `name` - The name of the value to get.
      Returns:
        The value.
      Throws:
        `JSONValueNotFoundException` - if no such mapping exists.

    - #### getOrDefault

          public java.lang.Object getOrDefault​(java.lang.Object key,
                                               java.lang.Object defaultValue)

      Returns the value to which the specified key is mapped, or `defaultValue` if this JSONObject contains no mapping for the key.
      Specified by:
        `getOrDefault` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Parameters:
        `key` - the key whose associated value is to be returned
        `defaultValue` - the default mapping of the key
      Returns:
        the value to which the specified key is mapped, or `defaultValue` if this JSONObject contains no mapping for the key
      Since:
        5.7

    - #### remove

          public java.lang.Object remove​(java.lang.Object name)

      Removes the named mapping if it exists; does nothing otherwise.
      Specified by:
        `remove` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Parameters:
        `name` - The name of the mapping to remove.
      Returns:
        the value previously mapped by `name`, or null if there was no such mapping.

    - #### putAll

          public void putAll​(java.util.Map<? extends java.lang.String,​? extends java.lang.Object> newProperties)

      Invokes `put(String, Object)` for each value from the map.
      Specified by:
        `putAll` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Parameters:
        `newProperties` - to add to this JSONObject
      Since:
        5.7

    - #### clear

          public void clear()

      Removes all of the mappings from this JSONObject.
      Specified by:
        `clear` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Since:
        5.7

    - #### keySet

          public java.util.Set<java.lang.String> keySet()

      Returns a `Set` view of the keys contained in this JSONObject. The set is backed by the JSONObject, so changes to the map are reflected in the set, and vice-versa.
      Specified by:
        `keySet` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Returns:
        a set view of the keys contained in this JSONObject
      Since:
        5.7

    - #### values

          public java.util.Collection<java.lang.Object> values()

      Returns a `Collection` view of the values contained in this JSONObject. The collection is backed by the JSONObject, so changes to the map are reflected in the collection, and vice-versa.
      Specified by:
        `values` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Returns:
        a collection view of the values contained in this JSONObject
      Since:
        5.7

    - #### entrySet

          public java.util.Set<java.util.Map.Entry<java.lang.String,​java.lang.Object>> entrySet()

      Returns a `Set` view of the mappings contained in this JSONObject. The set is backed by the JSONObject, so changes to the map are reflected in the set, and vice-versa.
      Specified by:
        `entrySet` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Returns:
        a set view of the mappings contained in this JSONObject
      Since:
        5.7

    - #### merge

          public java.lang.Object merge​(java.lang.String key,
                                        java.lang.Object value,
                                        java.util.function.BiFunction<? super java.lang.Object,​? super java.lang.Object,​? extends java.lang.Object> remappingFunction)

      If the specified key is not already associated with a value or is associated with null, associates it with the given non-null value. Otherwise, replaces the associated value with the results of the given remapping function, or removes if the result is `null`.
      Specified by:
        `merge` in interface `java.util.Map<java.lang.String,​java.lang.Object>`
      Parameters:
        `key` - key with which the resulting value is to be associated
        `value` - the non-null value to be merged with the existing value associated with the key or, if no existing value or a null value is associated with the key, to be associated with the key
        `remappingFunction` - the function to recompute a value if present
      Returns:
        the new value associated with the specified key, or null if no value is associated with the key
      Throws:
        `java.lang.NullPointerException` - if the specified key is null or the value or remappingFunction is null
      Since:
        5.7